<!DOCTYPE html>

<html lang="en" data-content_root="../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

    <title>Getting started &#8212; pydecha 0.3+13.g1a2fafa.dirty documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css?v=b3523f8e" />
    <link rel="stylesheet" type="text/css" href="../_static/alabaster.css?v=cb25574f" />
    <script src="../_static/documentation_options.js?v=2fb7d489"></script>
    <script src="../_static/doctools.js?v=888ff710"></script>
    <script src="../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Tutorial for new module" href="../modules/new_module.html" />
    <link rel="prev" title="Installation" href="installation.html" />
   
  <link rel="stylesheet" href="../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <section id="getting-started">
<h1>Getting started<a class="headerlink" href="#getting-started" title="Link to this heading">¶</a></h1>
<section id="configuration">
<h2>Configuration<a class="headerlink" href="#configuration" title="Link to this heading">¶</a></h2>
<p>The configuration file must follow a template describing the order and
the process which the pipeline will go through.</p>
<p>Below, we will describe the differnet field consisting the configuration file:</p>
<dl class="field-list simple">
<dt class="field-odd">general<span class="colon">:</span></dt>
<dd class="field-odd"><p></p></dd>
</dl>
<div class="highlight-yaml notranslate"><div class="highlight"><pre><span></span><span class="nt">general</span><span class="p">:</span>
<span class="w">  </span><span class="nt">date_fmt</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;%Y-%m-%d_%H-%M-%S&#39;</span>
<span class="w">  </span><span class="nt">author</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;Hari</span><span class="nv"> </span><span class="s">Seldon&#39;</span>
<span class="w">  </span><span class="nt">setup</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;setupname&#39;</span>
<span class="w">  </span><span class="nt">detector</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;detectornumber&#39;</span>
<span class="w">  </span><span class="nt">version</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;&#39;</span>
<span class="w">  </span><span class="nt">savepath</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;outputs/&#39;</span>
</pre></div>
</div>
<p>In the general field, entries like author, setup and detector must be filled.
The field ‘version’ will be field with the last git version using ‘git describe –long’.</p>
<dl class="field-list simple">
<dt class="field-odd">workflow<span class="colon">:</span></dt>
<dd class="field-odd"><p></p></dd>
</dl>
<p>Within the workflow field, the user will describe which type of detector
he wants to use pydecha with.
Then, the workflow/list entry will describe for each module if the
acquisition, analysis and reporting module are being used.
Not listing a module in workflow/list will simply not use it. Listing
a module with three False value will import it but skip it in the pipelines.
(good test for the libraries)</p>
<div class="highlight-yaml notranslate"><div class="highlight"><pre><span></span><span class="nt">workflow</span><span class="p">:</span>
<span class="w">  </span><span class="c1"># Information about the detector and pipeline to run (cmos)</span>
<span class="w">  </span><span class="nt">detector</span><span class="p">:</span>
<span class="w">        </span><span class="nt">type</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;cmos&#39;</span>
<span class="w">        </span><span class="nt">dimensions</span><span class="p">:</span><span class="w"> </span><span class="l l-Scalar l-Scalar-Plain">4096</span>
<span class="w">        </span><span class="nt">nb_outputs</span><span class="p">:</span><span class="w"> </span><span class="l l-Scalar l-Scalar-Plain">64</span>
<span class="w">        </span><span class="nt">read_freq</span><span class="p">:</span><span class="w"> </span><span class="l l-Scalar l-Scalar-Plain">100000</span>
<span class="w">  </span><span class="c1"># List of the modules that will run and which block will be</span>
<span class="w">  </span><span class="c1"># executed</span>
<span class="w">  </span><span class="nt">list</span><span class="p">:</span>
<span class="w">        </span><span class="c1"># module_name:[acquisition?, analysis?, reporting?]</span>
<span class="w">        </span><span class="nt">demo</span><span class="p">:</span><span class="w"> </span><span class="p p-Indicator">[</span><span class="nv">False</span><span class="p p-Indicator">,</span><span class="nv">True</span><span class="p p-Indicator">,</span><span class="nv">False</span><span class="p p-Indicator">]</span>
<span class="w">  </span><span class="c1"># Using self.save_fig in analysis module allows the user to save</span>
<span class="w">  </span><span class="c1"># a figure in png. tag: True enable the automatic information tag</span>
<span class="w">  </span><span class="c1"># to the figure. tag: False to disable it (for all).</span>
<span class="w">  </span><span class="nt">plots</span><span class="p">:</span>
<span class="w">    </span><span class="nt">tag</span><span class="p">:</span><span class="w"> </span><span class="l l-Scalar l-Scalar-Plain">True</span>
</pre></div>
</div>
<dl class="field-list simple">
<dt class="field-odd">acquisition<span class="colon">:</span></dt>
<dd class="field-odd"><p></p></dd>
</dl>
<p>To be written in v2.0</p>
<dl class="field-list simple">
<dt class="field-odd">analysis<span class="colon">:</span></dt>
<dd class="field-odd"><p></p></dd>
</dl>
<p>The analysis module will use a set of data located in data_path to run
its algorithm.
:params module_name: yaml serializing of module demo_analysis
:params data_path: the path of the data that will be used for the analysis
:params module_params: parameters used for the module, no checking of the compatibility
of the parameters in respect to the module, be careful!
:params output: usually empty field that can be use to store important
value within the module</p>
<div class="highlight-yaml notranslate"><div class="highlight"><pre><span></span><span class="nt">analysis</span><span class="p">:</span>
<span class="w">  </span><span class="nt">template</span><span class="p">:</span>
<span class="w">        </span><span class="nt">path</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;modules/template/template_analysis/template_pythonscript.py&#39;</span>
<span class="w">  </span><span class="nt">list</span><span class="p">:</span>
<span class="w">        </span><span class="nt">demo</span><span class="p">:</span>
<span class="w">          </span><span class="nt">module_name</span><span class="p">:</span><span class="w"> </span><span class="kt">!!python/module:demo_analysis</span>
<span class="w">          </span><span class="nt">module_params</span><span class="p">:</span>
<span class="w">            </span><span class="nt">data_path</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;pathtodata&#39;</span>
<span class="w">                </span><span class="nt">param1</span><span class="p">:</span><span class="w"> </span><span class="l l-Scalar l-Scalar-Plain">2</span>
<span class="w">                </span><span class="nt">param2</span><span class="p">:</span>
<span class="w">                  </span><span class="nt">a</span><span class="p">:</span><span class="w"> </span><span class="s">&#39;string&#39;</span>
<span class="w">                  </span><span class="nt">b</span><span class="p">:</span><span class="w"> </span><span class="l l-Scalar l-Scalar-Plain">3.14</span>
<span class="w">          </span><span class="nt">output</span><span class="p">:</span>
</pre></div>
</div>
<dl class="field-list simple">
<dt class="field-odd">reporting<span class="colon">:</span></dt>
<dd class="field-odd"><p></p></dd>
</dl>
<p>To be written in v3.0</p>
</section>
<section id="modes">
<h2>Modes<a class="headerlink" href="#modes" title="Link to this heading">¶</a></h2>
<p>PYDECHA runs three different modes:</p>
<section id="doc-documentation">
<h3>[doc] documentation<a class="headerlink" href="#doc-documentation" title="Link to this heading">¶</a></h3>
<blockquote>
<div><p>Update current documentation using demo_config.yaml config file</p>
<blockquote>
<div><div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>python<span class="w"> </span>pydecha/run.py<span class="w"> </span>-vvv<span class="w"> </span>doc<span class="w"> </span>cmos<span class="w"> </span>-c<span class="w"> </span>demo_config.yaml<span class="w"> </span>-du
<span class="nb">cd</span><span class="w"> </span>docs/
make<span class="w"> </span>html
</pre></div>
</div>
</div></blockquote>
<p>Alternatively, you can run the following command line from pydecha root folder:</p>
<blockquote>
<div><div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>sphinx-build<span class="w"> </span>docs/source<span class="w"> </span>docs/html
</pre></div>
</div>
</div></blockquote>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The documentation will be then available in the following directory:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span><span class="o">[</span>pydecha_folder<span class="o">]</span>/docs/html/index.html
</pre></div>
</div>
</div>
</div></blockquote>
</section>
<section id="char-characterization">
<h3>[char] characterization<a class="headerlink" href="#char-characterization" title="Link to this heading">¶</a></h3>
<blockquote>
<div><p>Run characterization for cmos type using demo_config.yaml</p>
<blockquote>
<div><div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>python<span class="w"> </span>pydecha/run.py<span class="w"> </span>-vvv<span class="w"> </span>char<span class="w"> </span>cmos<span class="w"> </span>-c<span class="w"> </span>demo_config.yaml
</pre></div>
</div>
</div></blockquote>
<p>Run characterization for ccd type using demo_config.yaml</p>
<blockquote>
<div><div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>python<span class="w"> </span>pydecha/run.py<span class="w"> </span>-vvv<span class="w"> </span>char<span class="w"> </span>ccd<span class="w"> </span>-c<span class="w"> </span>TBD.yaml
</pre></div>
</div>
</div></blockquote>
</div></blockquote>
</section>
<section id="cm-module-creation">
<h3>[cm] module creation<a class="headerlink" href="#cm-module-creation" title="Link to this heading">¶</a></h3>
<blockquote>
<div><p>Creating a new module for cmos like sensor:</p>
<blockquote>
<div><div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>python<span class="w"> </span>pydecha/run.py<span class="w"> </span>-vvv<span class="w"> </span>cm<span class="w"> </span>cmos<span class="w"> </span>demomodule
</pre></div>
</div>
</div></blockquote>
<p>Creating a new module for ccd:</p>
<blockquote>
<div><div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>python<span class="w"> </span>pydecha/run.py<span class="w"> </span>-vvv<span class="w"> </span>cm<span class="w"> </span>ccd<span class="w"> </span>demomodule
</pre></div>
</div>
</div></blockquote>
</div></blockquote>
</section>
</section>
</section>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../index.html">pydecha</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Introduction</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="pydecha.html">PYDECHA</a></li>
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Getting started</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#configuration">Configuration</a></li>
<li class="toctree-l2"><a class="reference internal" href="#modes">Modes</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#doc-documentation">[doc] documentation</a></li>
<li class="toctree-l3"><a class="reference internal" href="#char-characterization">[char] characterization</a></li>
<li class="toctree-l3"><a class="reference internal" href="#cm-module-creation">[cm] module creation</a></li>
</ul>
</li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Characterization modules</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../modules/new_module.html">Tutorial for new module</a></li>
<li class="toctree-l1"><a class="reference internal" href="../modules/modules_ccd.html">Modules CCD</a></li>
<li class="toctree-l1"><a class="reference internal" href="../modules/modules_cmos.html">Modules CMOS</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">About</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../about/acronyms.html">Acronyms</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/changelog.html">Change log</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/faq.html">FAQ</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../about/references.html">References</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../index.html">Documentation overview</a><ul>
      <li>Previous: <a href="installation.html" title="previous chapter">Installation</a></li>
      <li>Next: <a href="../modules/new_module.html" title="next chapter">Tutorial for new module</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2019, European Southern Observatory.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="../_sources/introduction/first_steps.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>